Code

t/integration: Split query.sh into multiple tests.
authorSebastian Harl <sh@tokkee.org>
Sun, 1 Mar 2015 18:34:14 +0000 (19:34 +0100)
committerSebastian Harl <sh@tokkee.org>
Sun, 1 Mar 2015 18:34:14 +0000 (19:34 +0100)
t/Makefile.am
t/integration/client.sh [new file with mode: 0755]
t/integration/query.sh [deleted file]
t/integration/query_fetch.sh [new file with mode: 0755]
t/integration/query_list.sh [new file with mode: 0755]
t/integration/query_timeseries.sh [new file with mode: 0755]
t/integration/ssl.sh

index 3218c7b5aafc01d5ac2726c6d5df018dd9471134..4b233193ad6890d09f926027d9f573cc41b357d1 100644 (file)
@@ -133,9 +133,12 @@ endif
 
 if INTEGRATION_TESTING
 INTEGRATION_TESTS = \
+               integration/client.sh \
                integration/config.sh \
                integration/ssl.sh \
-               integration/query.sh \
+               integration/query_fetch.sh \
+               integration/query_list.sh \
+               integration/query_timeseries.sh \
                integration/matching.sh \
                integration/filter.sh
 
diff --git a/t/integration/client.sh b/t/integration/client.sh
new file mode 100755 (executable)
index 0000000..e7766ef
--- /dev/null
@@ -0,0 +1,83 @@
+#! /bin/bash
+#
+# SysDB -- t/integration/basic_query.sh
+# Copyright (C) 2012 Sebastian 'tokkee' Harl <sh@tokkee.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#
+# Integration tests covering basic client functionality.
+#
+
+set -ex
+
+source "$( dirname "$0" )/test_lib.sh"
+
+cat <<EOF > "$SYSDBD_CONF"
+Listen "$SOCKET_FILE"
+PluginDir "$PLUGIN_DIR"
+Interval 2
+
+LoadBackend mock_plugin
+<Backend "mock_plugin">
+</Backend>
+
+LoadPlugin mock_timeseries
+EOF
+
+run_sysdbd -D -C "$SYSDBD_CONF"
+wait_for_sysdbd
+
+# wait for initial data
+sleep 3
+
+# Usage errors.
+output="$( run_sysdb -H "$SOCKET_FILE" --invalid 2>&1 )" && exit 1
+echo "$output" | grep -F 'Usage:'
+output="$( run_sysdb -H "$SOCKET_FILE" extra 2>&1 )" && exit 1
+echo "$output" | grep -F 'Usage:'
+
+# Invalid user.
+output="$( run_sysdb_nouser -H "$SOCKET_FILE" \
+  -U $SYSDB_USER-invalid -c 'LIST hosts' 2>&1 )" && exit 1
+echo "$output" | grep -F 'Access denied'
+
+# Unreachable server.
+output="$( run_sysdb -H "${SOCKET_FILE}.doesnotexist" -c '' 2>&1 )" && exit 1
+echo "$output" | grep "Failed to connect to SysDBd"
+
+# On parse errors, expect a non-zero exit code.
+output="$( run_sysdb -H "$SOCKET_FILE" -c INVALID 2>&1 )" && exit 1
+echo "$output" | grep "Failed to parse query 'INVALID'"
+echo "$output" | grep "parse error: syntax error"
+
+# Empty query.
+output="$( run_sysdb -H "$SOCKET_FILE" -c '' )"
+test -z "$output"
+
+# Default user.
+output="$( run_sysdb_nouser -H "$SOCKET_FILE" -c '' )"
+
+stop_sysdbd
+
+# vim: set tw=78 sw=4 ts=4 noexpandtab :
diff --git a/t/integration/query.sh b/t/integration/query.sh
deleted file mode 100755 (executable)
index 4656856..0000000
+++ /dev/null
@@ -1,161 +0,0 @@
-#! /bin/bash
-#
-# SysDB -- t/integration/basic_query.sh
-# Copyright (C) 2012 Sebastian 'tokkee' Harl <sh@tokkee.org>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
-# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
-# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
-# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
-# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
-# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
-# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
-# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
-# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-
-#
-# Integration tests using basic queries.
-#
-
-set -ex
-
-source "$( dirname "$0" )/test_lib.sh"
-
-cat <<EOF > "$SYSDBD_CONF"
-Listen "$SOCKET_FILE"
-PluginDir "$PLUGIN_DIR"
-Interval 2
-
-LoadPlugin mock_timeseries
-EOF
-
-run_sysdbd -D -C "$SYSDBD_CONF"
-wait_for_sysdbd
-
-cat <<EOF > "${SYSDBD_CONF}.sender"
-Listen "${SOCKET_FILE}.sender"
-PluginDir "$PLUGIN_DIR"
-Interval 2
-
-LoadPlugin "store::network"
-<Plugin "store::network">
-  Server "$SOCKET_FILE"
-</Plugin>
-
-LoadBackend mock_plugin
-<Backend "mock_plugin">
-</Backend>
-EOF
-
-run_sysdbd_foreground -D -C "${SYSDBD_CONF}.sender" &
-SYSDBD_PID2=$!
-trap "kill \$SYSDBD_PID2" EXIT
-wait_for_sysdbd "${SOCKET_FILE}.sender"
-
-# wait for initial data
-sleep 3
-
-# Invalid user.
-output="$( run_sysdb_nouser -H "$SOCKET_FILE" \
-  -U $SYSDB_USER-invalid -c 'LIST hosts' 2>&1 )" && exit 1
-echo "$output" | grep -F 'Access denied'
-
-# On parse errors, expect a non-zero exit code.
-output="$( run_sysdb -H "$SOCKET_FILE" -c INVALID 2>&1 )" && exit 1
-echo "$output" | grep "Failed to parse query 'INVALID'"
-echo "$output" | grep "parse error: syntax error"
-
-# Empty query.
-output="$( run_sysdb -H "$SOCKET_FILE" -c '' )"
-test -z "$output"
-
-# Simple, successful commands.
-output="$( run_sysdb -H "$SOCKET_FILE" -c 'LIST hosts' )"
-echo "$output" \
-       | grep -F '"host1.example.com"' \
-       | grep -F '"host2.example.com"' \
-       | grep -F '"localhost"' \
-       | grep -F '"other.host.name"' \
-       | grep -F '"some.host.name"'
-
-output="$( echo 'LIST hosts;' | run_sysdb -H "$SOCKET_FILE" )" || echo $?
-echo "$output" \
-       | grep -F '"host1.example.com"' \
-       | grep -F '"host2.example.com"' \
-       | grep -F '"localhost"' \
-       | grep -F '"other.host.name"' \
-       | grep -F '"some.host.name"'
-
-output="$( run_sysdb -H "$SOCKET_FILE" -c 'LIST services' )"
-echo "$output" \
-       | grep -F '"host1.example.com"' \
-       | grep -F '"host2.example.com"' \
-       | grep -F '"localhost"' \
-       | grep -F '"some.host.name"' \
-       | grep -F '"mock service"' \
-       | grep -F '"other service"' \
-       | grep -F '"database"' \
-       | grep -F '"example service one"' \
-       | grep -F '"example service two"' \
-       | grep -F '"example service three"'
-
-output="$( run_sysdb -H "$SOCKET_FILE" -c "FETCH host 'host1.example.com'" )"
-echo "$output" \
-       | grep -F '"host1.example.com"' \
-       | grep -F '"mock service"' \
-       | grep -E '"other attribute".*"special value"'
-echo "$output" | grep -F 'host2.example.com' && exit 1
-echo "$output" | grep -F 'localhost' && exit 1
-echo "$output" | grep -F 'other.host.name' && exit 1
-echo "$output" | grep -F 'some.host.name' && exit 1
-
-output="$( run_sysdb -H "$SOCKET_FILE" \
-  -c "FETCH host 'host1.example.com' FILTER last_update < 0s" 2>&1 )" \
-  && exit 1
-echo "$output" | grep -F 'not found'
-
-(echo 'LIST hosts;'; sleep 1; echo "FETCH host 'host1.example.com'") \
-       | run_sysdb -H "$SOCKET_FILE"
-
-output="$( run_sysdb -H "$SOCKET_FILE" \
-       -c "FETCH host 'host1.example.com' FILTER age < 0s" 2>&1 )" && exit 1
-echo "$output" | grep -F 'not found'
-
-# When requesting information for unknown hosts, expect a non-zero exit code.
-output="$( run_sysdb -H "$SOCKET_FILE" \
-       -c "FETCH host 'does.not.exist'" 2>&1 )" && exit 1
-echo "$output" | grep -F 'not found'
-
-run_sysdb -H "$SOCKET_FILE" \
-               -c "TIMESERIES 'invalid.host'.'invalid-metric'" && exit 1
-
-# Does not work yet since there is no fetcher plugin.
-output="$( run_sysdb -H "$SOCKET_FILE" \
-       -c "TIMESERIES 'some.host.name'.'foo/bar/qux'" )"
-echo "$output" \
-       | grep -F '"value": "1.000000"' \
-       | grep -F '"value": "2.000000"' \
-       | grep -F '"value": "3.000000"' \
-       | grep -F '"value": "4.000000"' \
-       | grep -F '"value": "5.000000"' \
-       | grep -F '"value": "6.000000"' \
-       | grep -F '"value": "7.000000"' \
-       | grep -F '"value": "8.000000"' \
-       | grep -F '"value": "9.000000"' \
-       | grep -F '"value": "10.000000"'
-
-stop_sysdbd
-
-# vim: set tw=78 sw=4 ts=4 noexpandtab :
diff --git a/t/integration/query_fetch.sh b/t/integration/query_fetch.sh
new file mode 100755 (executable)
index 0000000..b9c8ff9
--- /dev/null
@@ -0,0 +1,100 @@
+#! /bin/bash
+#
+# SysDB -- t/integration/basic_query.sh
+# Copyright (C) 2012 Sebastian 'tokkee' Harl <sh@tokkee.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#
+# Integration tests using basic queries.
+#
+
+set -ex
+
+source "$( dirname "$0" )/test_lib.sh"
+
+cat <<EOF > "$SYSDBD_CONF"
+Listen "$SOCKET_FILE"
+PluginDir "$PLUGIN_DIR"
+Interval 2
+
+LoadPlugin mock_timeseries
+EOF
+
+run_sysdbd -D -C "$SYSDBD_CONF"
+wait_for_sysdbd
+
+cat <<EOF > "${SYSDBD_CONF}.sender"
+Listen "${SOCKET_FILE}.sender"
+PluginDir "$PLUGIN_DIR"
+Interval 2
+
+LoadPlugin "store::network"
+<Plugin "store::network">
+  Server "$SOCKET_FILE"
+</Plugin>
+
+LoadBackend mock_plugin
+<Backend "mock_plugin">
+</Backend>
+EOF
+
+run_sysdbd_foreground -D -C "${SYSDBD_CONF}.sender" &
+SYSDBD_PID2=$!
+trap "kill \$SYSDBD_PID2" EXIT
+wait_for_sysdbd "${SOCKET_FILE}.sender"
+
+# wait for initial data
+sleep 3
+
+# FETCH commands.
+output="$( run_sysdb -H "$SOCKET_FILE" -c "FETCH host 'host1.example.com'" )"
+echo "$output" \
+       | grep -F '"host1.example.com"' \
+       | grep -F '"mock service"' \
+       | grep -E '"other attribute".*"special value"'
+echo "$output" | grep -F 'host2.example.com' && exit 1
+echo "$output" | grep -F 'localhost' && exit 1
+echo "$output" | grep -F 'other.host.name' && exit 1
+echo "$output" | grep -F 'some.host.name' && exit 1
+
+output="$( run_sysdb -H "$SOCKET_FILE" \
+  -c "FETCH host 'host1.example.com' FILTER last_update < 0s" 2>&1 )" \
+  && exit 1
+echo "$output" | grep -F 'not found'
+
+(echo 'LIST hosts;'; sleep 1; echo "FETCH host 'host1.example.com'") \
+       | run_sysdb -H "$SOCKET_FILE"
+
+output="$( run_sysdb -H "$SOCKET_FILE" \
+       -c "FETCH host 'host1.example.com' FILTER age < 0s" 2>&1 )" && exit 1
+echo "$output" | grep -F 'not found'
+
+# When requesting information for unknown hosts, expect a non-zero exit code.
+output="$( run_sysdb -H "$SOCKET_FILE" \
+       -c "FETCH host 'does.not.exist'" 2>&1 )" && exit 1
+echo "$output" | grep -F 'not found'
+
+stop_sysdbd
+
+# vim: set tw=78 sw=4 ts=4 noexpandtab :
diff --git a/t/integration/query_list.sh b/t/integration/query_list.sh
new file mode 100755 (executable)
index 0000000..28c365b
--- /dev/null
@@ -0,0 +1,102 @@
+#! /bin/bash
+#
+# SysDB -- t/integration/basic_query.sh
+# Copyright (C) 2012 Sebastian 'tokkee' Harl <sh@tokkee.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#
+# Integration tests using basic queries.
+#
+
+set -ex
+
+source "$( dirname "$0" )/test_lib.sh"
+
+cat <<EOF > "$SYSDBD_CONF"
+Listen "$SOCKET_FILE"
+PluginDir "$PLUGIN_DIR"
+Interval 2
+
+LoadPlugin mock_timeseries
+EOF
+
+run_sysdbd -D -C "$SYSDBD_CONF"
+wait_for_sysdbd
+
+cat <<EOF > "${SYSDBD_CONF}.sender"
+Listen "${SOCKET_FILE}.sender"
+PluginDir "$PLUGIN_DIR"
+Interval 2
+
+LoadPlugin "store::network"
+<Plugin "store::network">
+  Server "$SOCKET_FILE"
+</Plugin>
+
+LoadBackend mock_plugin
+<Backend "mock_plugin">
+</Backend>
+EOF
+
+run_sysdbd_foreground -D -C "${SYSDBD_CONF}.sender" &
+SYSDBD_PID2=$!
+trap "kill \$SYSDBD_PID2" EXIT
+wait_for_sysdbd "${SOCKET_FILE}.sender"
+
+# wait for initial data
+sleep 3
+
+# LIST commands.
+output="$( run_sysdb -H "$SOCKET_FILE" -c 'LIST hosts' )"
+echo "$output" \
+       | grep -F '"host1.example.com"' \
+       | grep -F '"host2.example.com"' \
+       | grep -F '"localhost"' \
+       | grep -F '"other.host.name"' \
+       | grep -F '"some.host.name"'
+
+output="$( echo 'LIST hosts;' | run_sysdb -H "$SOCKET_FILE" )" || echo $?
+echo "$output" \
+       | grep -F '"host1.example.com"' \
+       | grep -F '"host2.example.com"' \
+       | grep -F '"localhost"' \
+       | grep -F '"other.host.name"' \
+       | grep -F '"some.host.name"'
+
+output="$( run_sysdb -H "$SOCKET_FILE" -c 'LIST services' )"
+echo "$output" \
+       | grep -F '"host1.example.com"' \
+       | grep -F '"host2.example.com"' \
+       | grep -F '"localhost"' \
+       | grep -F '"some.host.name"' \
+       | grep -F '"mock service"' \
+       | grep -F '"other service"' \
+       | grep -F '"database"' \
+       | grep -F '"example service one"' \
+       | grep -F '"example service two"' \
+       | grep -F '"example service three"'
+
+stop_sysdbd
+
+# vim: set tw=78 sw=4 ts=4 noexpandtab :
diff --git a/t/integration/query_timeseries.sh b/t/integration/query_timeseries.sh
new file mode 100755 (executable)
index 0000000..e0eb9c8
--- /dev/null
@@ -0,0 +1,90 @@
+#! /bin/bash
+#
+# SysDB -- t/integration/basic_query.sh
+# Copyright (C) 2012 Sebastian 'tokkee' Harl <sh@tokkee.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#
+# Integration tests using basic queries.
+#
+
+set -ex
+
+source "$( dirname "$0" )/test_lib.sh"
+
+cat <<EOF > "$SYSDBD_CONF"
+Listen "$SOCKET_FILE"
+PluginDir "$PLUGIN_DIR"
+Interval 2
+
+LoadPlugin mock_timeseries
+EOF
+
+run_sysdbd -D -C "$SYSDBD_CONF"
+wait_for_sysdbd
+
+cat <<EOF > "${SYSDBD_CONF}.sender"
+Listen "${SOCKET_FILE}.sender"
+PluginDir "$PLUGIN_DIR"
+Interval 2
+
+LoadPlugin "store::network"
+<Plugin "store::network">
+  Server "$SOCKET_FILE"
+</Plugin>
+
+LoadBackend mock_plugin
+<Backend "mock_plugin">
+</Backend>
+EOF
+
+run_sysdbd_foreground -D -C "${SYSDBD_CONF}.sender" &
+SYSDBD_PID2=$!
+trap "kill \$SYSDBD_PID2" EXIT
+wait_for_sysdbd "${SOCKET_FILE}.sender"
+
+# wait for initial data
+sleep 3
+
+# TIMESERIES commands.
+run_sysdb -H "$SOCKET_FILE" \
+               -c "TIMESERIES 'invalid.host'.'invalid-metric'" && exit 1
+
+output="$( run_sysdb -H "$SOCKET_FILE" \
+       -c "TIMESERIES 'some.host.name'.'foo/bar/qux'" )"
+echo "$output" \
+       | grep -F '"value": "1.000000"' \
+       | grep -F '"value": "2.000000"' \
+       | grep -F '"value": "3.000000"' \
+       | grep -F '"value": "4.000000"' \
+       | grep -F '"value": "5.000000"' \
+       | grep -F '"value": "6.000000"' \
+       | grep -F '"value": "7.000000"' \
+       | grep -F '"value": "8.000000"' \
+       | grep -F '"value": "9.000000"' \
+       | grep -F '"value": "10.000000"'
+
+stop_sysdbd
+
+# vim: set tw=78 sw=4 ts=4 noexpandtab :
index c68494afbe7617e3da7d742e2803544aee9b28f3..cea2380087aa7626cf91e32943d623461db47fc1 100755 (executable)
@@ -48,6 +48,9 @@ wait_for_sysdbd_tcp localhost 12345
 run_sysdb -H "localhost:12345" -c 'LIST hosts' -U "$SYSDB_USER-invalid" \
        -A "$CA_CERT" -C "$CLIENT_CERT" -K "$CLIENT_KEY" && exit 1
 
+run_sysdb -H "localhost:12345" -c 'LIST hosts' -U "$SYSDB_USER-invalid" \
+       -A "$CA_CERT" -C "${CLIENT_CERT}.doesnotexist" -K "$CLIENT_KEY" && exit 1
+
 run_sysdb -H "localhost:12345" -c 'LIST hosts' -U "$SYSDB_USER" \
        -A "$CA_CERT" -C "$CLIENT_CERT" -K "$CLIENT_KEY"